/**************************************************************************************************
  HTTP.c
  This html code was borrowed from Mikroe's Weather Station.




**************************************************************************************************/
#include "HTTP.h"
#include "Buffers.h"
#include "Common.h"
#include "USB_Driver3.h"
#include "USART2_driver.h"

// Constants


// Variables




/**************************************************************************************************
  Some html web page.
**************************************************************************************************/
const code char indexPage1[] =   // Part 1 of page
"<html>\
<head>\
<style>\
body { font-family: Arial, Verdana; }\
table tr td { font-size: 0.9em; }\
p { font-size: 0.9em; margin:4px 0 4px 0; }\
h1 { font: 2.5em Arial, Verdana; color: #999999; text-align:center; padding:15px 0 20px 0; margin:0; border-bottom: 1px solid #bababa; }\
h2 { font: 3.8em Arial, Verdana; font-weight:bold; margin:0; }\
.main { margin:20px 0 0 13%; }\
.temperature { float: left; width:49%; border-right:1px solid #bababa; min-width:700px; }\
.humidity { float: left; width:50%; }\
.mikroelab { border-top:1px solid #bababa; padding:20px 0 20px 5%; }\
.highlight { font: 1.5em Impact, Arial, Verdana; color:#F00; margin:3px 0 3px 0; }\
@media screen and (max-width: 1400px) {\
.temperature { border-right: 0; }\
.humidity { border-top: 1px solid #bababa; width:100%; margin-top:24px; }\
}\
</style>\
<script type='text/javascript' src='https://www.google.com/jsapi'></script>\
<script type='text/javascript'>\
google.load('visualization', '1', {packages:['corechart']});\
google.setOnLoadCallback(drawChart);\
var chart;\
var chart1;\
var options;\
var options1;\
var data;\
var data1;\
var lowT = null;\
var highT = null;\
function drawChart()\
{\
data = new google.visualization.DataTable();\
data1 = new google.visualization.DataTable();\
data.addColumn ('datetime', 'Time');\
data.addColumn ('number', 'Temperature');\
data.addColumn ('number', 'High threshold');\
data.addColumn ('number', 'Low threshold');\
data1.addColumn ('datetime', 'Time');\
data1.addColumn ('number', 'Relative humidity');\
options =\
{\
backgroundColor: { fill:'transparent' },\
title: 'Temperature',\
width: '700',\
height: '400',\
curveType: 'function',\
series: {\
0:{color: 'red'},\
1:{curveType:'none', color:'yellow'},\
2:{curveType:'none', color:'green'}\
},\
hAxis: {format: 'HH:mm'}\
};\
options1 =\
{\
backgroundColor: { fill:'transparent' },\
title: 'Relative humidity',\
width: '700',\
height: '400',\
curveType: 'function',\
hAxis: {format: 'HH:mm'}\
};\
chart = new google.visualization.LineChart(document.getElementById('chart_div1'));\
chart.draw(data, options);\
chart1 = new google.visualization.LineChart(document.getElementById('chart_div2'));\
chart1.draw(data1, options1);\
}\
function addToGraph(temp1, temp2)\
{\
data.addRows([[new Date(), Number(temp1), highT, lowT]]);\
chart.draw(data, options);\
data1.addRows([[new Date(), Number(temp2)]]);\
chart1.draw(data1, options1);\
}\
</script>\
<script>\
var txt = '';\
var hiTh,lowTh,port1,port2,pin1,pin2;\
setInterval(function() {\
loadXMLDoc();}, 1000 * 5);\
function loadXMLDoc()\
{\
var xmlhttp;\
var txt;\
if (window.XMLHttpRequest)\
{\
xmlhttp=new XMLHttpRequest();\
}\
else\
{\
xmlhttp=new ActiveXObject('Microsoft.XMLHTTP');\
}\
xmlhttp.open('GET','s',true);\
xmlhttp.send();\
xmlhttp.onreadystatechange=function()\
{\
if (xmlhttp.readyState==4 && xmlhttp.status==200)\
{\
txt=xmlhttp.responseText;\
document.getElementById('temperature').innerHTML = txt.substring(0,txt.indexOf(';'))+'&deg;'+'C';\
document.getElementById('humidity').innerHTML = txt.substring(txt.indexOf(';')+1,txt.length)+'%';\
var t = txt.substring(0,txt.indexOf(';'));\
var v = txt.substring(txt.indexOf(';')+1,txt.length);\
addToGraph(t,v)\
}\
}\
}\
function sendHTMLReq(request)\
{\
var xmlhttp2;\
if (window.XMLHttpRequest)\
{\
xmlhttp2=new XMLHttpRequest();\
}\
else\
{\
xmlhttp2=new ActiveXObject('Microsoft.XMLHTTP');\
}\
xmlhttp2.open('GET',request,true);\
xmlhttp2.send();\
xmlhttp2.onreadystatechange=function()\
{\
if (xmlhttp2.readyState==4 && xmlhttp2.status==200)\
{\
document.getElementById('ime').innerHTML=xmlhttp2.responseText;\
highT = Number(hiTh);\
lowT = Number(lowTh);\
}\
}\
}\
function resetHTMLReq()\
{\
var xmlhttp3;\
if (window.XMLHttpRequest)\
{\
xmlhttp3=new XMLHttpRequest();\
}\
else\
{\
xmlhttp3=new ActiveXObject('Microsoft.XMLHTTP');\
}\
xmlhttp3.open('GET','r',true);\
xmlhttp3.send();\
xmlhttp3.onreadystatechange=function()\
{\
if (xmlhttp3.readyState==4 && xmlhttp3.status==200)\
{\
document.getElementById('ime').innerHTML=xmlhttp3.responseText;\
}\
}\
}\
function hiThVal()\
{\
hiTh=document.getElementById('hiThVal').value;\
if (hiTh.length===1) hiTh = '00' + hiTh;\
else if (hiTh.length===2) hiTh = '0' + hiTh;\
}\
function lowThVal()\
{\
lowTh=document.getElementById('lowThVal').value;\
if (lowTh.length===1) lowTh = '00' + lowTh;\
else if (lowTh.length===2) lowTh = '0' + lowTh;\
}\
function sendReq()\
{\
if ((hiTh === undefined) || (hiTh === ''))\
document.getElementById('ime').innerHTML = 'High threshold value error';\
else if ((lowTh === undefined) || (lowTh === ''))\
document.getElementById('ime').innerHTML = 'Low threshold value error';\
else\
{\
var request = 't'+hiTh+lowTh;\
sendHTMLReq(request);\
}\
}\
function resetReq()\
{\
document.getElementById('hiThVal').value = '';\
document.getElementById('lowThVal').value = '';\
hiTh = undefined;\
lowTh = undefined;\
highT = null;\
lowT = null;\
resetHTMLReq();\
}\
</script>\
</head>\
<body>\
<h1>mikromedia WiFi Weather Station</h1>\
<div class='temperature'>\
<div class='main'>\
<p style='color:red; margin-bottom:2px;'>Temperature</p>\
<h2 id='temperature' style='color:red;'>00.00C</h2>\
</div>\
<div id='chart_div1'></div>\
<div style='margin-left:10%; padding-bottom:20px; margin-top:-40px;'>\
<h3 style='font: 1.5em Arial, Verdana; margin-bottom:20px;'>Temperature regulator</h3>\
<table id='MyTable2'>\
<tr style='padding-bottom:10px;'>\
<td><span style='display:block; height:15px; width:15px; background-color:yellow;'></span></td>\
<td height='30' style='font-size:0.9em;'>High threshold value:</td>\
<td height='30'><input type='text' id='hiThVal' onchange='hiThVal()' style='border:1px solid #000; height:25px;'></td>\
<td height='30'>(PA1 = 1)</td>\
</tr>\
<tr>\
<td><span style='display:block; height:15px; width:15px; background-color:green;'></span></td>\
<td height='30'>Low threshold value:</td>\
<td height='30'><input type='text' id='lowThVal' onchange='lowThVal()' style='border:1px solid #000; height:25px;'></td>\
<td height='30'>(PA2 = 1)</td>\
</tr>\
<tr>\
<td height='30' style='color:#f00;' id='ime' colspan='4'></td>\
</tr>\
</table>\
<button type='button' onclick='sendReq()' style='margin:5px 0 0 188px'>Set</button>\
<button type='button' onclick='resetReq()' style='margin-top:5px;'>Reset</button>\
</div>\
</div>\
<div class='humidity'>\
<div class='main'>\
<p style='color:blue; margin-bottom:2px;'>Relative humidity</p>\
<h2 id='humidity' style='color:blue;'>00.00%</h2>\
</div>\
<div id='chart_div2'></div>\
</div>\
<div style='clear:both;'></div>\
<div class='mikroelab'>\
<p>Project by</p>\
<p class='highlight'>MikroElektronika Lab</p>\
<p>Hardware used: <a href='http://www.mikroe.com/mikromedia/stm32-m4/'>mikromedia for STM32 M4</a>, <a href='http://www.mikroe.com/mikromedia/shields/mikrobus/'>mikromedia mikroBUS shield</a>, <a href='http://www.mikroe.com/click/wifi-plus/'>WiFi Plus click</a>, <a href='http://www.mikroe.com/click/sht1x/'>SHT1x click</a></p>\
<p>Code written in: <a href='http://www.mikroe.com/mikroc/arm/'>mikroC PRO for ARM</a>, <a href='http://www.mikroe.com/mikropascal/arm/'>mikroPascal PRO for ARM</a>, <a href='http://www.mikroe.com/mikrobasic/arm/'>mikroBasic PRO for ARM</a></p>\
</div>\
</body>\
</html>";




void DisplaySizePage1(void) {
     char *BufNum;

     BufNum = GetBuffer();
     sprintf(BufNum,"The size of page 1 is: %d\r\n",sizeof(indexPage1));
     //USB_PutQueue(BufNum);
     USART2_PutQueue(BufNum);
}


/*
void DisplaySizePage2(void) {
     char *BufNum;

     BufNum = GetBuffer();
     sprintf(BufNum,"The size of page 2 is: %d\r\n",sizeof(indexPage2));
     //USB_PutQueue(BufNum);
     USART2_PutQueue(BufNum);
}

void DisplaySizePage3(void) {
     char *BufNum;

     BufNum = GetBuffer();
     sprintf(BufNum,"The size of page 3 is: %d\r\n",sizeof(indexPage3));
     //USB_PutQueue(BufNum);
     USART2_PutQueue(BufNum);
}
*/


void DisplayPageSize(const code char *PageName) {
     char *BufNum;

     BufNum = GetBuffer();
     sprintf(BufNum,"Size of data is: %d\r\n",strlen((char*)PageName));
     //USB_PutQueue(BufNum);
     USART2_PutQueue(BufNum);
}

/**************************************************************************************************
  End of File
**************************************************************************************************/