/**************************************************************************************************
 * Project name:
     Breskva.mcpar
  * Date of creation
     2019/02/18
 * Time of creation
     11:21:00 AM
 * Test configuration:
     MCU:             STM32F407VGT6
     Board:           EasyMx PRO v7 for STM32
     Oscillator:      25 MHz external crystal
     MPU Frequency:   120 MHz from PLL
     Compiler:        mikroC PRO for ARM Version 6.1.0
     Slot 1:          WiFi ESP click board
     Slot 2:          Empty
     Switch 11:       Switch 12:       Switch 13:       Switch 14:       Switch 15:
      1 - off          1 - off          1 - on           1 - off          1 - off
      2 - off          2 - off          2 - on           2 - off          2 - off
      3 - on           3 - on           3 - on           3 - on           3 - off
      4 - on           4 - on           4 - off          4 - on           4 - off
      5 - on           5 - off          5 - off          5 - off          5 - off
      6 - on           6 - off          6 - off          6 - off          6 - off
      7 - on           7 - on           7 - off          7 - off          7 - off
      8 - on           8 - off          8 - off          8 - off          8 - off

  * MikroE Libraries: ADC, Conversions, C_Stdlib, C_String, C_Type, Sprintf, TFT, TFT_Defs,
                      TFT_TouchPanel, UART, USB
  * FAT32Library:     None

  * This code is a test of the WiFi ESP click board.
  * Compiling the code generates 4 "Suspicious pointer conversion" messages from the FreeRTOS
    modules. You can ignore these messages.

**************************************************************************************************/

// Include files
#include <stdint.h>
#include <stddef.h>
#include "FreeRTOSConfig.h"
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"
#include "timers.h"
#include "projdefs.h"
#include "portmacro.h"

#include "main.h"
#include "Init_task.h"
//#include "MyTimers.h"
//#include "UART2_driver.h"
//#include "RTC.h"


// Variables




/**************************************************************************************************
  Main function, which creates the tasks and starts the scheduler
**************************************************************************************************/
void main() {

     // These setups are only used when MyTimers.c is included in the project
     // Create a FreeRTOS one-shot timer. The code is in MyTimers.c
     //CreateOneShotTimer();    // Only works if done here. Has to be started explicitly.

     // Create a FreeRTOS auto-reload timer. The code is in MyTimers.c
     //CreateAutoReloadTimer(); // Has to be started explicitly.


     // Create init task
     xTaskCreate (
          (TaskFunction_t)initTask,
          "Init Task",
          configMINIMAL_STACK_SIZE,
          NULL,
          10,
          NULL
     );

    // Start the RTOS scheduler
    vTaskStartScheduler();

    // Will never reach here
    while (1);
}

/**************************************************************************************************
  End of File
**************************************************************************************************/