_RTC_Initialize:
;RTC.c,43 :: 		void RTC_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;RTC.c,45 :: 		RCC_APB1ENR.PWREN = 1;             // Enable power interface clock
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
_SX	[R0, ByteOffset(RCC_APB1ENR+0)]
;RTC.c,47 :: 		if (RCC_BDCR.RTCEN == 0) {         // if RTC is disabled ...
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_RTC_Initialize0
;RTC.c,48 :: 		PWR_CR.DBP = 1;               // Allow access to RTC
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PWR_CR+0)
MOVT	R0, #hi_addr(PWR_CR+0)
_SX	[R0, ByteOffset(PWR_CR+0)]
;RTC.c,49 :: 		RTC_WPR = 0xCA;               // Unlock write protection
MOVS	R1, #202
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;RTC.c,50 :: 		RTC_WPR = 0x53;               // Unlock write protection
MOVS	R1, #83
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;RTC.c,52 :: 		RCC_BDCR = 0x00010000;        // Make it possible to change clock source
MOV	R1, #65536
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;RTC.c,53 :: 		RCC_BDCR = 0x00008101;        // Set RTCEN, LSE, LSEON
MOVW	R1, #33025
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;RTC.c,54 :: 		}
L_RTC_Initialize0:
;RTC.c,56 :: 		while(RTC_ISR.RSF != 1) {}         // Wait for RTC APB registers synchronization
L_RTC_Initialize1:
MOVW	R0, #lo_addr(RTC_ISR+0)
MOVT	R0, #hi_addr(RTC_ISR+0)
_LX	[R0, ByteOffset(RTC_ISR+0)]
CMP	R0, #0
IT	NE
BNE	L_RTC_Initialize2
IT	AL
BAL	L_RTC_Initialize1
L_RTC_Initialize2:
;RTC.c,57 :: 		while(RCC_BDCR.LSERDY != 1) {};    // Wait till LSE is ready
L_RTC_Initialize3:
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_RTC_Initialize4
IT	AL
BAL	L_RTC_Initialize3
L_RTC_Initialize4:
;RTC.c,59 :: 		RTC_WPR = 0xFF;                    // Set write protection register lock
MOVS	R1, #255
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;RTC.c,61 :: 		USB_PutQueue("RTC initialized\r\n");
MOVW	R0, #lo_addr(?lstr1_RTC+0)
MOVT	R0, #hi_addr(?lstr1_RTC+0)
BL	_USB_PutQueue+0
;RTC.c,62 :: 		}
L_end_RTC_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _RTC_Initialize
_RTC_Write:
;RTC.c,67 :: 		void RTC_Write(TTime *RTCC_Time) {
; RTCC_Time start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; RTCC_Time end address is: 0 (R0)
; RTCC_Time start address is: 0 (R0)
;RTC.c,70 :: 		PWR_CR.DBP = 1;                    // Enable access to RTC, RTC backup regs, SRAM
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(PWR_CR+0)
MOVT	R1, #hi_addr(PWR_CR+0)
_SX	[R1, ByteOffset(PWR_CR+0)]
;RTC.c,71 :: 		RTC_WPR = 0xCA;                    // Unlock write protection
MOVS	R2, #202
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,72 :: 		RTC_WPR = 0x53;                    // Unlock write protection
MOVS	R2, #83
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,74 :: 		RTC_ISR = 0x00000080;              // Set initialization mode (bit 7 of RTC_ISR)
MOVS	R2, #128
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
; RTCC_Time end address is: 0 (R0)
MOV	R5, R0
;RTC.c,76 :: 		while(RTC_ISR.INITF != 1) {};      // Wait for INITF (bit 6 of RTC_ISR) to come on
L_RTC_Write5:
; RTCC_Time start address is: 20 (R5)
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
_LX	[R1, ByteOffset(RTC_ISR+0)]
CMP	R1, #0
IT	NE
BNE	L_RTC_Write6
IT	AL
BAL	L_RTC_Write5
L_RTC_Write6:
;RTC.c,78 :: 		RTC_PRERbits.PREDIV_S = 0xFF;      // Set synchronous prescaler factor to 256
MOVS	R3, #255
MOVW	R2, #lo_addr(RTC_PRERbits+0)
MOVT	R2, #hi_addr(RTC_PRERbits+0)
LDRH	R1, [R2, #0]
BFI	R1, R3, #0, #15
STRH	R1, [R2, #0]
;RTC.c,79 :: 		RTC_PRERbits.PREDIV_A = 0x7F;      // Set asynchronous division factor to 128
MOVS	R3, #127
MOVW	R2, #lo_addr(RTC_PRERbits+0)
MOVT	R2, #hi_addr(RTC_PRERbits+0)
LDR	R1, [R2, #0]
BFI	R1, R3, #16, #7
STR	R1, [R2, #0]
;RTC.c,82 :: 		temp = (unsigned long)Dec2Bcd(RTCC_Time->hours) << 16;
ADDS	R1, R5, #3
LDRSB	R1, [R1, #0]
UXTB	R1, R1
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R4, R0
LSLS	R4, R4, #16
; temp start address is: 16 (R4)
;RTC.c,83 :: 		temp += (unsigned long)Dec2Bcd(RTCC_Time->minutes) << 8;
ADDS	R1, R5, #2
LDRSB	R1, [R1, #0]
UXTB	R1, R1
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
LSLS	R1, R1, #8
ADDS	R4, R4, R1
;RTC.c,84 :: 		temp += (unsigned long)Dec2Bcd(RTCC_Time->seconds);
ADDS	R1, R5, #1
LDRSB	R1, [R1, #0]
UXTB	R1, R1
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
ADDS	R2, R4, R1
; temp end address is: 16 (R4)
;RTC.c,86 :: 		RTC_TR = temp;                     // Set Time register in RTC
MOVW	R1, #lo_addr(RTC_TR+0)
MOVT	R1, #hi_addr(RTC_TR+0)
STR	R2, [R1, #0]
;RTC.c,89 :: 		temp = (unsigned long)Dec2Bcd16(RTCC_Time->year) << 16;
ADDS	R1, R5, #6
LDRSH	R1, [R1, #0]
UXTH	R1, R1
UXTH	R0, R1
BL	_Dec2Bcd16+0
UXTH	R4, R0
LSLS	R4, R4, #16
; temp start address is: 16 (R4)
;RTC.c,90 :: 		temp += (unsigned long)Dec2Bcd(RTCC_Time->month) << 8;
ADDS	R1, R5, #5
LDRSB	R1, [R1, #0]
UXTB	R1, R1
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
LSLS	R1, R1, #8
ADDS	R4, R4, R1
;RTC.c,91 :: 		temp += (unsigned long)Dec2Bcd(RTCC_Time->day);
ADDS	R1, R5, #4
; RTCC_Time end address is: 20 (R5)
LDRSB	R1, [R1, #0]
UXTB	R1, R1
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
ADDS	R2, R4, R1
; temp end address is: 16 (R4)
;RTC.c,92 :: 		RTC_DR = temp;                     // Set date register in RTC
MOVW	R1, #lo_addr(RTC_DR+0)
MOVT	R1, #hi_addr(RTC_DR+0)
STR	R2, [R1, #0]
;RTC.c,94 :: 		RTC_CRbits.FMT = 0;                // Set FMT 24H format
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(RTC_CRbits+0)
MOVT	R1, #hi_addr(RTC_CRbits+0)
_SX	[R1, ByteOffset(RTC_CRbits+0)]
;RTC.c,95 :: 		RTC_CRbits.WCKSEL = 0;             // Set RTC/16 clock
MOVS	R3, #0
MOVW	R2, #lo_addr(RTC_CRbits+0)
MOVT	R2, #hi_addr(RTC_CRbits+0)
LDRB	R1, [R2, #0]
BFI	R1, R3, #0, #3
STRB	R1, [R2, #0]
;RTC.c,97 :: 		RTC_ISR = 0x00000000;              // Exit initialization mode
MOVS	R2, #0
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
;RTC.c,99 :: 		RTC_WPR = 0xFF;                    // Enable the write protection for RTC registers
MOVS	R2, #255
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,100 :: 		}
L_end_RTC_Write:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _RTC_Write
_RTC_Read:
;RTC.c,105 :: 		void RTC_Read(TTime *RTCC_Time) {
; RTCC_Time start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
MOV	R4, R0
; RTCC_Time end address is: 0 (R0)
; RTCC_Time start address is: 16 (R4)
;RTC.c,107 :: 		RTC_Time = RTC_TR;                 // Read the time register
MOVW	R1, #lo_addr(RTC_TR+0)
MOVT	R1, #hi_addr(RTC_TR+0)
LDR	R1, [R1, #0]
MOVW	R3, #lo_addr(_RTC_Time+0)
MOVT	R3, #hi_addr(_RTC_Time+0)
STR	R1, [R3, #0]
;RTC.c,108 :: 		RTC_Date = RTC_DR;                 // Read the date register
MOVW	R1, #lo_addr(RTC_DR+0)
MOVT	R1, #hi_addr(RTC_DR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(_RTC_Date+0)
MOVT	R1, #hi_addr(_RTC_Date+0)
STR	R2, [R1, #0]
;RTC.c,111 :: 		RTCC_Time->hours = Bcd2Dec((short)((RTC_Time & 0x3F0000) >> 16));
ADDS	R1, R4, #3
STR	R1, [SP, #4]
MOV	R1, R3
LDR	R1, [R1, #0]
AND	R1, R1, #4128768
LSRS	R1, R1, #16
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #4]
STRB	R0, [R1, #0]
;RTC.c,112 :: 		RTCC_Time->minutes = Bcd2Dec((short)((RTC_Time & 0x007F00) >> 8));
ADDS	R1, R4, #2
STR	R1, [SP, #4]
MOVW	R1, #lo_addr(_RTC_Time+0)
MOVT	R1, #hi_addr(_RTC_Time+0)
LDR	R1, [R1, #0]
AND	R1, R1, #32512
LSRS	R1, R1, #8
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #4]
STRB	R0, [R1, #0]
;RTC.c,113 :: 		RTCC_Time->seconds = Bcd2Dec((short)(RTC_Time & 0x00007F));
ADDS	R1, R4, #1
STR	R1, [SP, #4]
MOVW	R1, #lo_addr(_RTC_Time+0)
MOVT	R1, #hi_addr(_RTC_Time+0)
LDR	R1, [R1, #0]
AND	R1, R1, #127
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #4]
STRB	R0, [R1, #0]
;RTC.c,116 :: 		RTCC_Time->year = Bcd2Dec16((unsigned)((RTC_Date & 0xFFFF0000) >> 16));
ADDS	R1, R4, #6
STR	R1, [SP, #4]
MOVW	R1, #lo_addr(_RTC_Date+0)
MOVT	R1, #hi_addr(_RTC_Date+0)
LDR	R2, [R1, #0]
MOVW	R1, #0
MOVT	R1, #65535
AND	R1, R2, R1, LSL #0
LSRS	R1, R1, #16
UXTH	R0, R1
BL	_Bcd2Dec16+0
LDR	R1, [SP, #4]
STRH	R0, [R1, #0]
;RTC.c,117 :: 		RTCC_Time->month = Bcd2Dec((short)((RTC_Date & 0x001F00) >> 8));
ADDS	R1, R4, #5
STR	R1, [SP, #4]
MOVW	R1, #lo_addr(_RTC_Date+0)
MOVT	R1, #hi_addr(_RTC_Date+0)
LDR	R1, [R1, #0]
AND	R1, R1, #7936
LSRS	R1, R1, #8
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #4]
STRB	R0, [R1, #0]
;RTC.c,118 :: 		RTCC_Time->day = Bcd2Dec((short)(RTC_Date & 0x00003F));
ADDS	R1, R4, #4
; RTCC_Time end address is: 16 (R4)
STR	R1, [SP, #4]
MOVW	R1, #lo_addr(_RTC_Date+0)
MOVT	R1, #hi_addr(_RTC_Date+0)
LDR	R1, [R1, #0]
AND	R1, R1, #63
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #4]
STRB	R0, [R1, #0]
;RTC.c,119 :: 		}
L_end_RTC_Read:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _RTC_Read
_RTC_WriteSRAM:
;RTC.c,124 :: 		void RTC_WriteSRAM(unsigned short Reg, unsigned long Value) {
; Value start address is: 4 (R1)
; Reg start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Value end address is: 4 (R1)
; Reg end address is: 0 (R0)
; Reg start address is: 0 (R0)
; Value start address is: 4 (R1)
;RTC.c,126 :: 		switch (Reg) {
IT	AL
BAL	L_RTC_WriteSRAM7
; Reg end address is: 0 (R0)
;RTC.c,127 :: 		case  0: RTC_BKP0R  = Value; break;
L_RTC_WriteSRAM9:
MOVW	R2, #lo_addr(RTC_BKP0R+0)
MOVT	R2, #hi_addr(RTC_BKP0R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,128 :: 		case  1: RTC_BKP1R  = Value; break;
L_RTC_WriteSRAM10:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP1R+0)
MOVT	R2, #hi_addr(RTC_BKP1R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,129 :: 		case  2: RTC_BKP2R  = Value; break;
L_RTC_WriteSRAM11:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP2R+0)
MOVT	R2, #hi_addr(RTC_BKP2R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,130 :: 		case  3: RTC_BKP3R  = Value; break;
L_RTC_WriteSRAM12:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP3R+0)
MOVT	R2, #hi_addr(RTC_BKP3R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,131 :: 		case  4: RTC_BKP4R  = Value; break;
L_RTC_WriteSRAM13:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP4R+0)
MOVT	R2, #hi_addr(RTC_BKP4R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,132 :: 		case  5: RTC_BKP5R  = Value; break;
L_RTC_WriteSRAM14:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP5R+0)
MOVT	R2, #hi_addr(RTC_BKP5R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,133 :: 		case  6: RTC_BKP6R  = Value; break;
L_RTC_WriteSRAM15:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP6R+0)
MOVT	R2, #hi_addr(RTC_BKP6R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,134 :: 		case  7: RTC_BKP7R  = Value; break;
L_RTC_WriteSRAM16:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP7R+0)
MOVT	R2, #hi_addr(RTC_BKP7R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,135 :: 		case  8: RTC_BKP8R  = Value; break;
L_RTC_WriteSRAM17:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP8R+0)
MOVT	R2, #hi_addr(RTC_BKP8R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,136 :: 		case  9: RTC_BKP9R  = Value; break;
L_RTC_WriteSRAM18:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP9R+0)
MOVT	R2, #hi_addr(RTC_BKP9R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,137 :: 		case 10: RTC_BKP10R = Value; break;
L_RTC_WriteSRAM19:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP10R+0)
MOVT	R2, #hi_addr(RTC_BKP10R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,138 :: 		case 11: RTC_BKP11R = Value; break;
L_RTC_WriteSRAM20:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP11R+0)
MOVT	R2, #hi_addr(RTC_BKP11R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,139 :: 		case 12: RTC_BKP12R = Value; break;
L_RTC_WriteSRAM21:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP12R+0)
MOVT	R2, #hi_addr(RTC_BKP12R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,140 :: 		case 13: RTC_BKP13R = Value; break;
L_RTC_WriteSRAM22:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP13R+0)
MOVT	R2, #hi_addr(RTC_BKP13R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,141 :: 		case 14: RTC_BKP14R = Value; break;
L_RTC_WriteSRAM23:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP14R+0)
MOVT	R2, #hi_addr(RTC_BKP14R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,142 :: 		case 15: RTC_BKP15R = Value; break;
L_RTC_WriteSRAM24:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP15R+0)
MOVT	R2, #hi_addr(RTC_BKP15R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,143 :: 		case 16: RTC_BKP16R = Value; break;
L_RTC_WriteSRAM25:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP16R+0)
MOVT	R2, #hi_addr(RTC_BKP16R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,144 :: 		case 17: RTC_BKP17R = Value; break;
L_RTC_WriteSRAM26:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP17R+0)
MOVT	R2, #hi_addr(RTC_BKP17R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,145 :: 		case 18: RTC_BKP18R = Value; break;
L_RTC_WriteSRAM27:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP18R+0)
MOVT	R2, #hi_addr(RTC_BKP18R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,146 :: 		case 19: RTC_BKP19R = Value; break;
L_RTC_WriteSRAM28:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP19R+0)
MOVT	R2, #hi_addr(RTC_BKP19R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,147 :: 		default: USB_PutQueue("Invalid reg address\r\n"); break;
L_RTC_WriteSRAM29:
MOVW	R2, #lo_addr(?lstr2_RTC+0)
MOVT	R2, #hi_addr(?lstr2_RTC+0)
MOV	R0, R2
BL	_USB_PutQueue+0
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,148 :: 		}
L_RTC_WriteSRAM7:
; Value start address is: 4 (R1)
; Reg start address is: 0 (R0)
CMP	R0, #0
IT	EQ
BEQ	L_RTC_WriteSRAM9
CMP	R0, #1
IT	EQ
BEQ	L_RTC_WriteSRAM10
CMP	R0, #2
IT	EQ
BEQ	L_RTC_WriteSRAM11
CMP	R0, #3
IT	EQ
BEQ	L_RTC_WriteSRAM12
CMP	R0, #4
IT	EQ
BEQ	L_RTC_WriteSRAM13
CMP	R0, #5
IT	EQ
BEQ	L_RTC_WriteSRAM14
CMP	R0, #6
IT	EQ
BEQ	L_RTC_WriteSRAM15
CMP	R0, #7
IT	EQ
BEQ	L_RTC_WriteSRAM16
CMP	R0, #8
IT	EQ
BEQ	L_RTC_WriteSRAM17
CMP	R0, #9
IT	EQ
BEQ	L_RTC_WriteSRAM18
CMP	R0, #10
IT	EQ
BEQ	L_RTC_WriteSRAM19
CMP	R0, #11
IT	EQ
BEQ	L_RTC_WriteSRAM20
CMP	R0, #12
IT	EQ
BEQ	L_RTC_WriteSRAM21
CMP	R0, #13
IT	EQ
BEQ	L_RTC_WriteSRAM22
CMP	R0, #14
IT	EQ
BEQ	L_RTC_WriteSRAM23
CMP	R0, #15
IT	EQ
BEQ	L_RTC_WriteSRAM24
CMP	R0, #16
IT	EQ
BEQ	L_RTC_WriteSRAM25
CMP	R0, #17
IT	EQ
BEQ	L_RTC_WriteSRAM26
CMP	R0, #18
IT	EQ
BEQ	L_RTC_WriteSRAM27
CMP	R0, #19
IT	EQ
BEQ	L_RTC_WriteSRAM28
; Reg end address is: 0 (R0)
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM29
L_RTC_WriteSRAM8:
;RTC.c,149 :: 		}
L_end_RTC_WriteSRAM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _RTC_WriteSRAM
_RTC_ReadSRAM:
;RTC.c,154 :: 		unsigned long RTC_ReadSRAM(unsigned short Reg) {
; Reg start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Reg end address is: 0 (R0)
; Reg start address is: 0 (R0)
;RTC.c,157 :: 		switch (Reg) {
IT	AL
BAL	L_RTC_ReadSRAM30
; Reg end address is: 0 (R0)
;RTC.c,158 :: 		case  0: Temp = RTC_BKP0R;  break;
L_RTC_ReadSRAM32:
MOVW	R1, #lo_addr(RTC_BKP0R+0)
MOVT	R1, #hi_addr(RTC_BKP0R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,159 :: 		case  1: Temp = RTC_BKP1R;  break;
L_RTC_ReadSRAM33:
MOVW	R1, #lo_addr(RTC_BKP1R+0)
MOVT	R1, #hi_addr(RTC_BKP1R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,160 :: 		case  2: Temp = RTC_BKP2R;  break;
L_RTC_ReadSRAM34:
MOVW	R1, #lo_addr(RTC_BKP2R+0)
MOVT	R1, #hi_addr(RTC_BKP2R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,161 :: 		case  3: Temp = RTC_BKP3R;  break;
L_RTC_ReadSRAM35:
MOVW	R1, #lo_addr(RTC_BKP3R+0)
MOVT	R1, #hi_addr(RTC_BKP3R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,162 :: 		case  4: Temp = RTC_BKP4R;  break;
L_RTC_ReadSRAM36:
MOVW	R1, #lo_addr(RTC_BKP4R+0)
MOVT	R1, #hi_addr(RTC_BKP4R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,163 :: 		case  5: Temp = RTC_BKP5R;  break;
L_RTC_ReadSRAM37:
MOVW	R1, #lo_addr(RTC_BKP5R+0)
MOVT	R1, #hi_addr(RTC_BKP5R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,164 :: 		case  6: Temp = RTC_BKP6R;  break;
L_RTC_ReadSRAM38:
MOVW	R1, #lo_addr(RTC_BKP6R+0)
MOVT	R1, #hi_addr(RTC_BKP6R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,165 :: 		case  7: Temp = RTC_BKP7R;  break;
L_RTC_ReadSRAM39:
MOVW	R1, #lo_addr(RTC_BKP7R+0)
MOVT	R1, #hi_addr(RTC_BKP7R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,166 :: 		case  8: Temp = RTC_BKP8R;  break;
L_RTC_ReadSRAM40:
MOVW	R1, #lo_addr(RTC_BKP8R+0)
MOVT	R1, #hi_addr(RTC_BKP8R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,167 :: 		case  9: Temp = RTC_BKP9R;  break;
L_RTC_ReadSRAM41:
MOVW	R1, #lo_addr(RTC_BKP9R+0)
MOVT	R1, #hi_addr(RTC_BKP9R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,168 :: 		case 10: Temp = RTC_BKP10R; break;
L_RTC_ReadSRAM42:
MOVW	R1, #lo_addr(RTC_BKP10R+0)
MOVT	R1, #hi_addr(RTC_BKP10R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,169 :: 		case 11: Temp = RTC_BKP11R; break;
L_RTC_ReadSRAM43:
MOVW	R1, #lo_addr(RTC_BKP11R+0)
MOVT	R1, #hi_addr(RTC_BKP11R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,170 :: 		case 12: Temp = RTC_BKP12R; break;
L_RTC_ReadSRAM44:
MOVW	R1, #lo_addr(RTC_BKP12R+0)
MOVT	R1, #hi_addr(RTC_BKP12R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,171 :: 		case 13: Temp = RTC_BKP13R; break;
L_RTC_ReadSRAM45:
MOVW	R1, #lo_addr(RTC_BKP13R+0)
MOVT	R1, #hi_addr(RTC_BKP13R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,172 :: 		case 14: Temp = RTC_BKP14R; break;
L_RTC_ReadSRAM46:
MOVW	R1, #lo_addr(RTC_BKP14R+0)
MOVT	R1, #hi_addr(RTC_BKP14R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,173 :: 		case 15: Temp = RTC_BKP15R; break;
L_RTC_ReadSRAM47:
MOVW	R1, #lo_addr(RTC_BKP15R+0)
MOVT	R1, #hi_addr(RTC_BKP15R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,174 :: 		case 16: Temp = RTC_BKP16R; break;
L_RTC_ReadSRAM48:
MOVW	R1, #lo_addr(RTC_BKP16R+0)
MOVT	R1, #hi_addr(RTC_BKP16R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,175 :: 		case 17: Temp = RTC_BKP17R; break;
L_RTC_ReadSRAM49:
MOVW	R1, #lo_addr(RTC_BKP17R+0)
MOVT	R1, #hi_addr(RTC_BKP17R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,176 :: 		case 18: Temp = RTC_BKP18R; break;
L_RTC_ReadSRAM50:
MOVW	R1, #lo_addr(RTC_BKP18R+0)
MOVT	R1, #hi_addr(RTC_BKP18R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,177 :: 		case 19: Temp = RTC_BKP19R; break;
L_RTC_ReadSRAM51:
MOVW	R1, #lo_addr(RTC_BKP19R+0)
MOVT	R1, #hi_addr(RTC_BKP19R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,178 :: 		default: USB_PutQueue("Invalid reg address\r\n"); Temp = 0; break;
L_RTC_ReadSRAM52:
MOVW	R1, #lo_addr(?lstr3_RTC+0)
MOVT	R1, #hi_addr(?lstr3_RTC+0)
MOV	R0, R1
BL	_USB_PutQueue+0
; Temp start address is: 0 (R0)
MOVS	R0, #0
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,179 :: 		}
L_RTC_ReadSRAM30:
; Reg start address is: 0 (R0)
CMP	R0, #0
IT	EQ
BEQ	L_RTC_ReadSRAM32
CMP	R0, #1
IT	EQ
BEQ	L_RTC_ReadSRAM33
CMP	R0, #2
IT	EQ
BEQ	L_RTC_ReadSRAM34
CMP	R0, #3
IT	EQ
BEQ	L_RTC_ReadSRAM35
CMP	R0, #4
IT	EQ
BEQ	L_RTC_ReadSRAM36
CMP	R0, #5
IT	EQ
BEQ	L_RTC_ReadSRAM37
CMP	R0, #6
IT	EQ
BEQ	L_RTC_ReadSRAM38
CMP	R0, #7
IT	EQ
BEQ	L_RTC_ReadSRAM39
CMP	R0, #8
IT	EQ
BEQ	L_RTC_ReadSRAM40
CMP	R0, #9
IT	EQ
BEQ	L_RTC_ReadSRAM41
CMP	R0, #10
IT	EQ
BEQ	L_RTC_ReadSRAM42
CMP	R0, #11
IT	EQ
BEQ	L_RTC_ReadSRAM43
CMP	R0, #12
IT	EQ
BEQ	L_RTC_ReadSRAM44
CMP	R0, #13
IT	EQ
BEQ	L_RTC_ReadSRAM45
CMP	R0, #14
IT	EQ
BEQ	L_RTC_ReadSRAM46
CMP	R0, #15
IT	EQ
BEQ	L_RTC_ReadSRAM47
CMP	R0, #16
IT	EQ
BEQ	L_RTC_ReadSRAM48
CMP	R0, #17
IT	EQ
BEQ	L_RTC_ReadSRAM49
CMP	R0, #18
IT	EQ
BEQ	L_RTC_ReadSRAM50
CMP	R0, #19
IT	EQ
BEQ	L_RTC_ReadSRAM51
; Reg end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM52
L_RTC_ReadSRAM31:
;RTC.c,180 :: 		return Temp;
; Temp start address is: 0 (R0)
; Temp end address is: 0 (R0)
;RTC.c,181 :: 		}
L_end_RTC_ReadSRAM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _RTC_ReadSRAM
_RTC_WriteCCR:
;RTC.c,189 :: 		void RTC_WriteCCR(char Cal) {
; Cal start address is: 0 (R0)
; Cal end address is: 0 (R0)
; Cal start address is: 0 (R0)
;RTC.c,191 :: 		PWR_CR.DBP = 1;                    // Enable access to RTC, RTC backup regs, SRAM
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(PWR_CR+0)
MOVT	R1, #hi_addr(PWR_CR+0)
_SX	[R1, ByteOffset(PWR_CR+0)]
;RTC.c,192 :: 		RTC_WPR = 0xCA;                    // Unlock write protection
MOVS	R2, #202
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,193 :: 		RTC_WPR = 0x53;                    // Unlock write protection
MOVS	R2, #83
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,194 :: 		RTC_ISR = 0x00000080;              // Set initialization mode (bit 7 of RTC_ISR)
MOVS	R2, #128
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
; Cal end address is: 0 (R0)
;RTC.c,195 :: 		while(RTC_ISR.INITF != 1) {};      // Wait for INITF (bit 6 of RTC_ISR) to come on
L_RTC_WriteCCR53:
; Cal start address is: 0 (R0)
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
_LX	[R1, ByteOffset(RTC_ISR+0)]
CMP	R1, #0
IT	NE
BNE	L_RTC_WriteCCR54
IT	AL
BAL	L_RTC_WriteCCR53
L_RTC_WriteCCR54:
;RTC.c,196 :: 		RTC_CALIBR = Cal;                  // Set calibration register with value supplied
MOVW	R1, #lo_addr(RTC_CALIBR+0)
MOVT	R1, #hi_addr(RTC_CALIBR+0)
STR	R0, [R1, #0]
; Cal end address is: 0 (R0)
;RTC.c,197 :: 		RTC_ISR = 0x00000000;              // Exit initialization mode
MOVS	R2, #0
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
;RTC.c,198 :: 		RTC_WPR = 0xFF;                    // Set write protection register lock
MOVS	R2, #255
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,199 :: 		}
L_end_RTC_WriteCCR:
BX	LR
; end of _RTC_WriteCCR
_RTC_ReadCCR:
;RTC.c,204 :: 		void RTC_ReadCCR(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;RTC.c,207 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;RTC.c,208 :: 		sprintf(BufNum,"%04X\r\n",RTC_CALIBR);
MOVW	R1, #lo_addr(RTC_CALIBR+0)
MOVT	R1, #hi_addr(RTC_CALIBR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_4_RTC+0)
MOVT	R1, #hi_addr(?lstr_4_RTC+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;RTC.c,209 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;RTC.c,210 :: 		}
L_end_RTC_ReadCCR:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _RTC_ReadCCR
_SetTime:
;RTC.c,215 :: 		void SetTime(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;RTC.c,216 :: 		MyTime.ampm = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(_MyTime+0)
MOVT	R0, #hi_addr(_MyTime+0)
STRB	R1, [R0, #0]
;RTC.c,217 :: 		MyTime.seconds = 30;
MOVS	R1, #30
SXTB	R1, R1
MOVW	R0, #lo_addr(_MyTime+1)
MOVT	R0, #hi_addr(_MyTime+1)
STRB	R1, [R0, #0]
;RTC.c,218 :: 		MyTime.minutes = 00;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(_MyTime+2)
MOVT	R0, #hi_addr(_MyTime+2)
STRB	R1, [R0, #0]
;RTC.c,219 :: 		MyTime.hours = 14;
MOVS	R1, #14
SXTB	R1, R1
MOVW	R0, #lo_addr(_MyTime+3)
MOVT	R0, #hi_addr(_MyTime+3)
STRB	R1, [R0, #0]
;RTC.c,220 :: 		MyTime.day = 16;
MOVS	R1, #16
SXTB	R1, R1
MOVW	R0, #lo_addr(_MyTime+4)
MOVT	R0, #hi_addr(_MyTime+4)
STRB	R1, [R0, #0]
;RTC.c,221 :: 		MyTime.month = 12;
MOVS	R1, #12
SXTB	R1, R1
MOVW	R0, #lo_addr(_MyTime+5)
MOVT	R0, #hi_addr(_MyTime+5)
STRB	R1, [R0, #0]
;RTC.c,222 :: 		MyTime.year = 16;
MOVS	R1, #16
SXTH	R1, R1
MOVW	R0, #lo_addr(_MyTime+6)
MOVT	R0, #hi_addr(_MyTime+6)
STRH	R1, [R0, #0]
;RTC.c,223 :: 		RTC_Write(&MyTime);
MOVW	R0, #lo_addr(_MyTime+0)
MOVT	R0, #hi_addr(_MyTime+0)
BL	_RTC_Write+0
;RTC.c,224 :: 		USB_PutQueue("Time and date set in RTC\r\n");
MOVW	R0, #lo_addr(?lstr5_RTC+0)
MOVT	R0, #hi_addr(?lstr5_RTC+0)
BL	_USB_PutQueue+0
;RTC.c,225 :: 		}
L_end_SetTime:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _SetTime
_GetTime:
;RTC.c,230 :: 		void GetTime(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;RTC.c,233 :: 		RTC_Read(&MyTime);
MOVW	R0, #lo_addr(_MyTime+0)
MOVT	R0, #hi_addr(_MyTime+0)
BL	_RTC_Read+0
;RTC.c,234 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 32 (R8)
MOV	R8, R0
;RTC.c,245 :: 		MyTime.hours,MyTime.minutes,MyTime.seconds);
MOVW	R1, #lo_addr(_MyTime+1)
MOVT	R1, #hi_addr(_MyTime+1)
LDRSB	R7, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+2)
MOVT	R1, #hi_addr(_MyTime+2)
LDRSB	R6, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+3)
MOVT	R1, #hi_addr(_MyTime+3)
LDRSB	R5, [R1, #0]
;RTC.c,244 :: 		sprintf(BufNum,"20%02d/%02d/%02d %02d:%02d:%02d\r\n",MyTime.year,MyTime.month,MyTime.day,
MOVW	R1, #lo_addr(_MyTime+4)
MOVT	R1, #hi_addr(_MyTime+4)
LDRSB	R4, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+5)
MOVT	R1, #hi_addr(_MyTime+5)
LDRSB	R3, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+6)
MOVT	R1, #hi_addr(_MyTime+6)
LDRSH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_6_RTC+0)
MOVT	R1, #hi_addr(?lstr_6_RTC+0)
;RTC.c,245 :: 		MyTime.hours,MyTime.minutes,MyTime.seconds);
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
;RTC.c,244 :: 		sprintf(BufNum,"20%02d/%02d/%02d %02d:%02d:%02d\r\n",MyTime.year,MyTime.month,MyTime.day,
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
;RTC.c,245 :: 		MyTime.hours,MyTime.minutes,MyTime.seconds);
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;RTC.c,246 :: 		USB_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_USB_PutQueue+0
;RTC.c,247 :: 		}
L_end_GetTime:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _GetTime
_GetTimeStampStr:
;RTC.c,252 :: 		char* GetTimeStampStr(void){
SUB	SP, SP, #40
STR	LR, [SP, #0]
;RTC.c,253 :: 		char TimeStamp[32] = {0};
ADD	R11, SP, #8
ADD	R10, R11, #32
MOVW	R12, #lo_addr(?ICSGetTimeStampStr_TimeStamp_L0+0)
MOVT	R12, #hi_addr(?ICSGetTimeStampStr_TimeStamp_L0+0)
BL	___CC2DW+0
;RTC.c,260 :: 		RTC_Read(&MyTime);
MOVW	R0, #lo_addr(_MyTime+0)
MOVT	R0, #hi_addr(_MyTime+0)
BL	_RTC_Read+0
;RTC.c,261 :: 		TimeStamp[0] = 0x08; // length
ADD	R2, SP, #8
MOVS	R0, #8
STRB	R0, [R2, #0]
;RTC.c,263 :: 		TimeStamp[2] = MyTime.year;
ADDS	R1, R2, #2
MOVW	R0, #lo_addr(_MyTime+6)
MOVT	R0, #hi_addr(_MyTime+6)
LDRSH	R0, [R0, #0]
STRB	R0, [R1, #0]
;RTC.c,264 :: 		TimeStamp[3] = MyTime.month;
ADDS	R1, R2, #3
MOVW	R0, #lo_addr(_MyTime+5)
MOVT	R0, #hi_addr(_MyTime+5)
LDRSB	R0, [R0, #0]
STRB	R0, [R1, #0]
;RTC.c,265 :: 		TimeStamp[4] = MyTime.day;
ADDS	R1, R2, #4
MOVW	R0, #lo_addr(_MyTime+4)
MOVT	R0, #hi_addr(_MyTime+4)
LDRSB	R0, [R0, #0]
STRB	R0, [R1, #0]
;RTC.c,266 :: 		TimeStamp[5] = MyTime.hours;
ADDS	R1, R2, #5
MOVW	R0, #lo_addr(_MyTime+3)
MOVT	R0, #hi_addr(_MyTime+3)
LDRSB	R0, [R0, #0]
STRB	R0, [R1, #0]
;RTC.c,267 :: 		TimeStamp[6] = MyTime.minutes;
ADDS	R1, R2, #6
MOVW	R0, #lo_addr(_MyTime+2)
MOVT	R0, #hi_addr(_MyTime+2)
LDRSB	R0, [R0, #0]
STRB	R0, [R1, #0]
;RTC.c,268 :: 		TimeStamp[7] = MyTime.seconds;
ADDS	R1, R2, #7
MOVW	R0, #lo_addr(_MyTime+1)
MOVT	R0, #hi_addr(_MyTime+1)
LDRSB	R0, [R0, #0]
STRB	R0, [R1, #0]
;RTC.c,272 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 32 (R8)
MOV	R8, R0
;RTC.c,276 :: 		TimeStamp[5],TimeStamp[6], TimeStamp[7]);
ADD	R2, SP, #8
ADDS	R1, R2, #7
LDRB	R1, [R1, #0]
UXTB	R7, R1
ADDS	R1, R2, #6
LDRB	R1, [R1, #0]
UXTB	R6, R1
ADDS	R1, R2, #5
LDRB	R1, [R1, #0]
UXTB	R5, R1
;RTC.c,275 :: 		sprintf(BufNum,"%02d/%02d/%02d %02d:%02d:%02d",TimeStamp[2],TimeStamp[3],TimeStamp[4],
ADDS	R1, R2, #4
LDRB	R1, [R1, #0]
UXTB	R4, R1
ADDS	R1, R2, #3
LDRB	R1, [R1, #0]
UXTB	R3, R1
ADDS	R1, R2, #2
LDRB	R1, [R1, #0]
UXTB	R2, R1
MOVW	R1, #lo_addr(?lstr_7_RTC+0)
MOVT	R1, #hi_addr(?lstr_7_RTC+0)
;RTC.c,276 :: 		TimeStamp[5],TimeStamp[6], TimeStamp[7]);
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
;RTC.c,275 :: 		sprintf(BufNum,"%02d/%02d/%02d %02d:%02d:%02d",TimeStamp[2],TimeStamp[3],TimeStamp[4],
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
;RTC.c,276 :: 		TimeStamp[5],TimeStamp[6], TimeStamp[7]);
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;RTC.c,278 :: 		USB_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_USB_PutQueue+0
;RTC.c,279 :: 		return TimeStamp;
ADD	R0, SP, #8
;RTC.c,280 :: 		}
L_end_GetTimeStampStr:
LDR	LR, [SP, #0]
ADD	SP, SP, #40
BX	LR
; end of _GetTimeStampStr
