// Put constant data to local buffer. When buffer overflow send data to WiFi module
unsigned int    PutConstString(const code char *s)
{
  unsigned int numOfSentBytes;

  while(*s)
  {
   txBuffer[bufferIndex++] = *s++;
    if(bufferIndex == MAX_SIZE_OF_DATA)
    {
      Net_Wireless_MCW1001_TCP_SendBytes(socketChild, txBuffer, MAX_SIZE_OF_DATA, &numOfSentBytes);
      bufferIndex = 0;
    }
  }
  return(bufferIndex) ;
}

// Put data to local buffer. When buffer overflow send data to WiFi module
unsigned int    PutString(char *s)
{
  unsigned int numOfSentBytes;

  while(*s)
  {
    txBuffer[bufferIndex++] = *s++;
    if(bufferIndex == MAX_SIZE_OF_DATA)
    {
      Net_Wireless_MCW1001_TCP_SendBytes(socketChild, txBuffer, MAX_SIZE_OF_DATA, &numOfSentBytes);
      bufferIndex = 0;
    }
  }
  return(bufferIndex) ;
}

// Send http request response
void SendHttpResponse()
{
  unsigned int numOfReceiveBytes = 0, numOfSentBytes;
  unsigned int    length;

  length = 0;
  Net_Wireless_MCW1001_TCP_ReadBytes(&socketChild, 12, getRequest, &numOfReceiveBytes);            // Read request
  getRequest[12] = 0;

  if(memcmp(getRequest, httpMethod, 5))                                                            // Check is request sent using GET method, only GET is supported
  {
    return;
  }

  httpCounter++ ;
  if(getRequest[5] == 's')                                                                         // If request path starts with s, return data in string format, details in test.html
  {
    Read_SHT11(&temperature, &rel_humidity);
    checkThreshold();
    TFT_Rectangle(100, 50, 320, 102);
    TFT_Rectangle(100, 150, 320, 252);
    bufferIndex = 0;
    PutConstString(httpHeader);                                                                    // Put response header
    PutConstString(httpMimeTypeScript);
    FloatToStr(temperature, dyna) ;                                                                // Put temperature data
    dyna[5] = '\0';
    PutString(dyna) ;
    PutConstString(";") ;
    dyna[5] = '';
    dyna[6] = 'C';
    dyna[7] = '\0';
    TFT_Write_Text(dyna, 100, 50);
    FloatToStr(rel_humidity, dyna);                                                                // Put humidity data
    dyna[5] = '\0';
    PutString(dyna) ;
    dyna[5] = '%';
    dyna[6] = '\0';
    TFT_Write_Text(dyna, 100, 150);
    length = PutConstString("") ;
    if(length != 0)                                                                                // If buffer is not empty, send data from buffer
      Net_Wireless_MCW1001_TCP_SendBytes(socketChild, txBuffer, length, &numOfSentBytes);
  }
  else if (getRequest[5] == 't')                                                                   // If request path starts with t, set threshold limits sent from page, details in test.html
  {
   bufferIndex = 0;
   setThreshold();
   PutConstString(httpHeader);
   PutConstString(httpMimeTypeScript);
   length = PutConstString("SUCCESS");
   if(length != 0)
      Net_Wireless_MCW1001_TCP_SendBytes(socketChild, txBuffer, length, &numOfSentBytes);
  }
  else if (getRequest[5] == 'r')                                                                   // If request path starts with r, turn off alarm and disable threshold limits, details in test.html
  {
   bufferIndex = 0;
   resetThreshold();
   PutConstString(httpHeader);
   PutConstString(httpMimeTypeScript);
   length = PutConstString("RESET");
   if(length != 0)
      Net_Wireless_MCW1001_TCP_SendBytes(socketChild, txBuffer, length, &numOfSentBytes);
  }
  if(length == 0)                                                                                  // Default request, load whole page
  {
    bufferIndex = 0;
    PutConstString(httpHeader) ;                                                                   // Request header
    PutConstString(httpMimeTypeHTML) ;                                                             //
    PutConstString(indexPage) ;                                                                    // Page, part 1
    length = PutConstString(indexPage2) ;                                                          // Page, part 2
    if(length != 0)
      Net_Wireless_MCW1001_TCP_SendBytes(socketChild, txBuffer, length, &numOfSentBytes);          // If buffer is not empty, send data from buffer
  }
}

// Start HTTP server
void RunHttpServer()
{
  while(1)
  {
    socketHandle = 0;
    backLog = 1;
    localPort = 80;
    Net_Wireless_MCW1001_SocketCreate(&socketHandle, _NET_WIRELESS_MCW1001_SOCKET_TYPE_TCP);       // Create TCP socket
    Net_Wireless_MCW1001_SocketBind(socketHandle, &localPort, &bindResponse);                      // Bind socket to the listen port
    Net_Wireless_MCW1001_TCP_Listen(socketHandle, &backLog, &listenResponse);                      // Prepare the socket to listen for connection with one children socket

    while(1)
    {
      socketChild = socketHandle;
      Net_Wireless_MCW1001_TCP_Accept(&socketChild, &remotePort, remoteIpAdd);                     // Accept incoming connection
      if (socketChild != 254)                                                                      // Accept function set socketChild.
      {                                                                                            // If socketChild == 254 there is no incoming connection
        break;
      }
    }
    SendHttpResponse();                                                                            // Send response
    Net_Wireless_MCW1001_SocketClose(socketChild);                                                 // Close sockets
    Net_Wireless_MCW1001_SocketClose(socketHandle);
  }
}
