/**************************************************************************************************
  UART2ForFreeRTOS.h
**************************************************************************************************/
#ifndef USART2_DRIVER_H
#define USART2_DRIVER_H

// Defines
#define DC3 0x13         // XOFF control character
#define DC1 0x11         // XON control character
#define NUL 0x00         // NUL control character

#define U2_RCV_BUF_SIZE 256
#define U2_RCV_BYTE_Q_LENGTH 128

// Structures
// Structures
typedef void (*tPtrFcn)(void);  // Pointer to a function

// Function Prototypes
void USART2_SetBaud(void);
void USART2_RxQueueInit(void);
void USART2_StartRx(void);
void USART2_RcvInit(void);
void USART2_Rx(void);
void USART2_Rx1(void);
void USART2_Rx2(void);

void USART2_PutQueue(char *msg);
void USART2_StartTx(void);
void USART2_SendMsg(char *s);
void USART2_Tx(void);


#endif


/**************************************************************************************************
  End of File
**************************************************************************************************/